<?php


namespace Schaffen\Login\Login\Managers;


use Freelabois\LaravelQuickstart\Extendables\ManipulationManager;
use Illuminate\Support\Facades\DB;
use Schaffen\Login\Login\Repositories\CompanyRepository;
use Schaffen\Login\Login\Repositories\UserRepository;


class UserManager extends ManipulationManager
{
    protected CompanyRepository $company_repository;

    public function __construct(UserRepository $repository, CompanyRepository $company_repository)
    {
        parent::__construct($repository);
        $this->company_repository = $company_repository;
    }


    public function login(string $username, string $password)
    {
        $companies = $this->company_repository->findMany(["emp_status" => 1]);
        $users = [];
        $i = 0;
        foreach ($companies as $company) {
//            dump($company->emp_banco);
            if ($company->emp_url == '177.101.153.95') {
                config([
                    'database.connections.dynamicdb' => [
                        'driver' => 'pgsql',
                        'host' => env('APP_ENV') !== "dev" ? $company->emp_url : 'localhost',
                        'port' => '5432',
                        'database' => $company->emp_banco,
                        'username' => env('APP_ENV') !== 'dev' ? env('DB_USERNAME') : env('LOCAL_DATABASE_USERNAME'),
                        'password' => env('APP_ENV') !== 'dev' ? env('DB_PASSWORD') : env('LOCAL_DATABASE_PASSWORD'),
//                        'username' => 'adv_line',
//                        'password' => '!@#4dvl1n3@!',
                        'schema' => 'acesso'
                    ]

                ]);

                DB::purge('dynamicdb');
//                DB::purge('mysql');

                $user = $this->repository->findByUserAndPassword($username, md5($password));

                $i++;
                if (!is_null($user)) {
                    $users[] = array_merge($user->toArray(), ['EmpBanco' => $company->emp_banco]);
                }
            }
//            if($i == 10) {
//                break;
//            }
        }


        return collect($users);
    }


}
